/* sorgente: VettIONome.c */

/*
** programma che illustra le modalita' di acquisizione
** e di restituzione del contenuto di un vettore di
** interi utilizzando il nome dei suoi elementi
*/

/* direttive per il preprocessore */

#include <stdio.h>
#define DIM_VETT 5

/*
** funzione per il calcolo della somma del contenuto di
** un vettore di interi
*/
int SommaVettInt(int *Vett, int dim)
  {
  /* definizione della variabile per la scansione del
  ** vettore */
  int pos;
  
  /* definizione della variabile per la somma
  ** degli elementi del vettore e sua inizializzazione */
  int somma = 0;
  
  /* scandisco gli elementi del vettore */
  for (pos = 0; pos < dim;)
	/* aggiorno il valore corrente di somma */
	somma = somma + Vett[pos++];
  
  return(somma);
  }
/*
** funzione per l'acquisizione del contenuto di
** un vettore di interi
*/
void AcqVettInt(int Vett[], int dim)
  {
  /* definizione della variabile per la scansione del
  ** vettore */
  int pos;
  
  /* scansione del vettore e acquisizione del suo
  ** contenuto */
  for (pos = 0; pos < dim; pos++)
    {
    printf("\nVett[%d]? ", pos);
    scanf("%d", &Vett[pos]);
    };
  }

/*
** funzione per la restituzione del contenuto di
** un vettore di interi
*/
void ResVettInt(int Vett[], int dim)
  {
  /* definizione della variabile per la scansione del
  ** vettore */
  int pos;
  
  /* scansione del vettore e restituzione del suo
  ** contenuto */
  for (pos = 0; pos < dim; pos++)
    printf("\nVett[%d]: %d", pos, Vett[pos]);
  }
  
/* Chiamante */

int main()
  {
  /* definizione di un vettore di interi */
  int prova[DIM_VETT];
  
  /* acquisizione del contenuto del vettore */
  AcqVettInt(prova, DIM_VETT);
  
  /* restituzione del contenuto del vettore */
  ResVettInt(prova, DIM_VETT);
  
  /* calcolo e restituisco la somma degli elementi del vettore */
  printf("\nLa somma e': %d\n",SommaVettInt(prova, DIM_VETT));
  
  return(1);
  }
